/* -*- Mode: C; c-basic-offset:4 ; -*- */
/* 
 *   $Id: ad_hfs_close.c,v 1.7 2003/02/18 23:10:47 robl Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "ad_hfs.h"

void ADIOI_HFS_Close(ADIO_File fd, int *error_code)
{   
    int err;
#ifndef PRINT_ERR_MSG
    static char myname[] = "ADIOI_HFS_CLOSE";
#endif
    
    err = close(fd->fd_sys);
    if ( err == -1 ) {
#ifdef MPICH2
        *error_code = MPIR_Err_create_code(MPI_ERR_IO, "**io",
                            "**io %s", strerror(errno));
        MPIR_Err_return_file(fd, myname, *error_code);

#elif defined(PRINT_ERR_MSG)
        *error_code =  MPI_ERR_UNKNOWN;
#else /* MPICH-1 */
        *error_code = MPIR_Err_setmsg(MPI_ERR_IO, MPIR_ADIO_ERROR,
                              myname, "I/O Error", "%s", strerror(errno));
        ADIOI_Error(fd, *error_code, myname);
#endif
    }
    else *error_code = MPI_SUCCESS;
}
